<?xml version="1.0" encoding="UTF-8"?>
<!--
 * Scicos
 * 
 * Copyright (C) INRIA - METALAU Project <scicos@inria.fr> (HTML version)
 * Copyright (C) DIGITEO - Scilab Consortium (XML Docbook version)
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * See the file ./license.txt
 -->
<refentry xmlns="http://docbook.org/ns/docbook" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:svg="http://www.w3.org/2000/svg" xmlns:mml="http://www.w3.org/1998/Math/MathML" xmlns:db="http://docbook.org/ns/docbook" version="5.0-subset Scilab" xml:id="generic_block3">
  <refnamediv>
    <refname>generic_block3</refname>
    <refpurpose>Generic block</refpurpose>
  </refnamediv>
  <refsection>
    <title>Block Screenshot</title>
    <para>
      <inlinemediaobject>
        <imageobject>
          <imagedata fileref="../../../../images/palettes/generic_block3.jpg" align="center" valign="middle"/>
        </imageobject>
      </inlinemediaobject>
    </para>
  </refsection>
  <refsection id="Contents_generic_block3">
    <title>Contents</title>
    <itemizedlist>
      <listitem>
        <para>
          <link linkend="generic_block3">Generic block</link>
        </para>
      </listitem>
      <listitem>
        <itemizedlist>
          <listitem>
            <para>
              <xref linkend="Palette_generic_block3">Palette</xref>
            </para>
          </listitem>
          <listitem>
            <para>
              <xref linkend="Description_generic_block3">Description</xref>
            </para>
          </listitem>
          <listitem>
            <para>
              <xref linkend="Dialogbox_generic_block3">Dialog box</xref>
            </para>
          </listitem>
          <listitem>
            <para>
              <xref linkend="Defaultproperties_generic_block3">Default properties</xref>
            </para>
          </listitem>
          <listitem>
            <para>
              <xref linkend="Interfacingfunction_generic_block3">Interfacing function</xref>
            </para>
          </listitem>
          <listitem>
            <para>
              <xref linkend="Computationalfunction_generic_block3">Computational function</xref>
            </para>
          </listitem>
          <listitem>
            <para>
              <xref linkend="Authors_generic_block3">Authors</xref>
            </para>
          </listitem>
        </itemizedlist>
      </listitem>
    </itemizedlist>
  </refsection>
  <refsection id="Palette_generic_block3">
    <title>Palette</title>
    <itemizedlist>
      <listitem>
        <para>
          <link linkend="Userdefinedfunctions_pal">User defined functions palette</link>
        </para>
      </listitem>
    </itemizedlist>
  </refsection>
  <refsection id="Description_generic_block3">
    <title>Description</title>
    <para>
The block provides a generic interfacing function but the
computational function needs to be defined separately, either as a
Scilab function or  a Fortran or a C function. Besides the name of the
function, user should specify information such as the type, whether or
not the block contains a direct feed-through term. The function
realising computational functions of generic blocks of a Scicos
diagram must be saved along with the diagram and loaded or dynamically
linked before simulation. 

</para>
  </refsection>
  <refsection id="Dialogbox_generic_block3">
    <title>Dialog box</title>
    <para>
      <inlinemediaobject>
        <imageobject>
          <imagedata fileref="../../../../images/gui/generic_block3_gui.gif" align="center" valign="middle"/>
        </imageobject>
      </inlinemediaobject>
    </para>
    <para>

</para>
    <itemizedlist>
      <listitem>
        <para>
          <emphasis role="bold">Simulation function</emphasis>
        </para>
        <para> Name of the function to be loaded.</para>
        <para> Properties : Type 'str' of size 1 </para>
      </listitem>
      <listitem>
        <para>
          <emphasis role="bold">Function type </emphasis>
        </para>
        <para> Type of the computational function supported by Scicos.</para>
        <para> Properties : Type 'vec' of size 1 </para>
      </listitem>
      <listitem>
        <para>
          <emphasis role="bold">Input ports sizes</emphasis>
        </para>
        <para> Number of regular input ports.</para>
        <para> Properties : Type 'mat' of size [-1,2] </para>
      </listitem>
      <listitem>
        <para>
          <emphasis role="bold">Input ports type</emphasis>
        </para>
        <para> Set the datatype of the regular input ports.</para>
        <para> Properties : Type 'vec' of size -1 </para>
      </listitem>
      <listitem>
        <para>
          <emphasis role="bold">Iutput port sizes</emphasis>
        </para>
        <para> Number of regular input ports.</para>
        <para> Properties : Type 'mat' of size [-1,2] </para>
      </listitem>
      <listitem>
        <para>
          <emphasis role="bold">Output ports type</emphasis>
        </para>
        <para> Set the datatype of the regular output ports.</para>
        <para> Properties : Type 'vec' of size -1 </para>
      </listitem>
      <listitem>
        <para>
          <emphasis role="bold">Input event ports sizes</emphasis>
        </para>
        <para> a vector of ones, size of event input ports. The size of the vector gives the number of event input ports.</para>
        <para> Properties : Type 'vec' of size -1 </para>
      </listitem>
      <listitem>
        <para>
          <emphasis role="bold">Output events ports sizes</emphasis>
        </para>
        <para> a vector of ones, size of event output ports. The size of the vector gives the number of of event output ports.</para>
        <para> Properties : Type 'vec' of size -1 </para>
      </listitem>
      <listitem>
        <para>
          <emphasis role="bold">Initial continuous state</emphasis>
        </para>
        <para> A column vector of Initial State Conditions.</para>
        <para> Properties : Type 'vec' of size -1 </para>
      </listitem>
      <listitem>
        <para>
          <emphasis role="bold">Initial discrete state</emphasis>
        </para>
        <para> A column vector Initial discrete Conditions.</para>
        <para> Properties : Type 'vec' of size -1 </para>
      </listitem>
      <listitem>
        <para>
          <emphasis role="bold">Initial object state</emphasis>
        </para>
        <para> A Scilab list that defined the initial object state (oz).</para>
        <para> Properties : Type 'lis' of size -1 </para>
      </listitem>
      <listitem>
        <para>
          <emphasis role="bold">Real parameters vector</emphasis>
        </para>
        <para> column vector. Any parameters used in the block can be defined here as a column vector.</para>
        <para> Properties : Type 'vec' of size -1 </para>
      </listitem>
      <listitem>
        <para>
          <emphasis role="bold">Integer parameters vector</emphasis>
        </para>
        <para> column vector. Any integer parameters used in the block can be defined here as a column vector.</para>
        <para> Properties : Type 'vec' of size -1 </para>
      </listitem>
      <listitem>
        <para>
          <emphasis role="bold">Object parameters list  </emphasis>
        </para>
        <para> A Scilab list that defined the list of the Object parameters (opar).</para>
        <para> Properties : Type 'lis' of size -1 </para>
      </listitem>
      <listitem>
        <para>
          <emphasis role="bold">Number of modes</emphasis>
        </para>
        <para> Number of Right hand side functions in the system.</para>
        <para> Properties : Type 'vec' of size 1 </para>
      </listitem>
      <listitem>
        <para>
          <emphasis role="bold">Number of zero_crossings</emphasis>
        </para>
        <para> No. of zero-crossings</para>
        <para> Properties : Type 'vec' of size 1 </para>
      </listitem>
      <listitem>
        <para>
          <emphasis role="bold">Initial firing vector </emphasis>
        </para>
        <para> vector. Size of this vector corresponds to the number of event outputs. The value of the i-th entry specifies the time of the preprogrammed event firing on the i-th output event port. If less than zero, no event is preprogrammed.</para>
        <para> Properties : Type 'vec' of size sum(%6) </para>
      </listitem>
      <listitem>
        <para>
          <emphasis role="bold">Direct feedthrough </emphasis>
        </para>
        <para> character "y" or "n", specifies if block has a direct input to output feedthrough.</para>
        <para> Properties : Type 'vec' of size 1 </para>
      </listitem>
      <listitem>
        <para>
          <emphasis role="bold">Time dependence </emphasis>
        </para>
        <para> Time dependance : character "y" or "n", specifies if block output depends explicitly on time.</para>
        <para> Properties : Type 'vec' of size 1</para>
      </listitem>
    </itemizedlist>
  </refsection>
  <refsection id="Defaultproperties_generic_block3">
    <title>Default properties</title>
    <itemizedlist>
      <listitem>
        <para><emphasis role="bold">always active:</emphasis> no</para>
      </listitem>
      <listitem>
        <para><emphasis role="bold">direct-feedthrough:</emphasis> yes</para>
      </listitem>
      <listitem>
        <para><emphasis role="bold">zero-crossing:</emphasis> no</para>
      </listitem>
      <listitem>
        <para><emphasis role="bold">mode:</emphasis> no</para>
      </listitem>
      <listitem>
        <para>
          <emphasis role="bold">regular inputs:</emphasis>
        </para>
        <para>
          <emphasis role="bold">- port 1 : size [1,1] / type 1</emphasis>
        </para>
      </listitem>
      <listitem>
        <para>
          <emphasis role="bold">regular outputs:</emphasis>
        </para>
        <para>
          <emphasis role="bold">- port 1 : size [1,1] / type 1</emphasis>
        </para>
      </listitem>
      <listitem>
        <para><emphasis role="bold">number/sizes of activation inputs:</emphasis> 0</para>
      </listitem>
      <listitem>
        <para><emphasis role="bold">number/sizes of activation outputs:</emphasis> 0</para>
      </listitem>
      <listitem>
        <para><emphasis role="bold">continuous-time state:</emphasis> no</para>
      </listitem>
      <listitem>
        <para><emphasis role="bold">discrete-time state:</emphasis> no</para>
      </listitem>
      <listitem>
        <para><emphasis role="bold">object discrete-time state:</emphasis> no</para>
      </listitem>
      <listitem>
        <para>
          <emphasis role="bold">name of computational function:</emphasis>
          <emphasis role="italic">sinblk</emphasis>
        </para>
      </listitem>
    </itemizedlist>
  </refsection>
  <refsection id="Interfacingfunction_generic_block3">
    <title>Interfacing function</title>
    <itemizedlist>
      <listitem>
        <para> SCI/modules/scicos_blocks/macros/Misc/generic_block3.sci</para>
      </listitem>
    </itemizedlist>
  </refsection>
  <refsection id="Computationalfunction_generic_block3">
    <title>Computational function</title>
    <itemizedlist>
      <listitem>
        <para> SCI/modules/scicos_blocks/src/fortran/sinblk.f (Type 4)</para>
      </listitem>
    </itemizedlist>
  </refsection>
  <refsection id="Authors_generic_block3">
    <title>Authors</title>
    <para>
      <emphasis role="bold"/>
    </para>
    <itemizedlist>
      <listitem>
        <para><emphasis role="bold">Alan Layec</emphasis> INRIA</para>
      </listitem>
      <listitem>
        <para><emphasis role="bold">Ramine Nikoukhah</emphasis> INRIA</para>
      </listitem>
    </itemizedlist>
  </refsection>
</refentry>
